#import <Foundation/Foundation.h>
#import "SWGBatch.h"
#import "SWGBatchError.h"
#import "SWGApi.h"

/**
* Browshot API
* Take screenshots of any website in real time
*
* OpenAPI spec version: 1.16.0
* Contact: support@browshot.com
*
* NOTE: This class is auto generated by the swagger code generator program.
* https://github.com/swagger-api/swagger-codegen.git
* Do not edit the class manually.
*/



@interface SWGBatchApi: NSObject <SWGApi>

extern NSString* kSWGBatchApiErrorDomain;
extern NSInteger kSWGBatchApiMissingParamErrorCode;

+(instancetype) sharedAPI;

/// Requests thousands of screenshtos at once
/// Get hundreds or thousands of screenshots from a text file. You can use this API call or the dashboard. Unlike the other API calls, you must issue a POST request with the Content-Type \"multipart/form-data\" in order to upload the text file. The text file must contain the list of URLs to request, 1 URL per line. Failed screenshots will be tried up to 3 times before giving up. 
///
/// @param instanceId instance ID to use
/// @param file text file to use (optional)
/// @param size screenshots size - \"screen\" (default) or \"page\" (optional) (default to screen)
/// @param name name of the batch (optional)
/// @param width thumbnail width. (optional) (default to 1024)
/// @param height thumbnail height (optional)
/// @param delay number of seconds to wait after the page has loaded. This is used to let JavaScript run longer before taking the screenshot. Use delay=0 to take screenshots faster. (optional) (default to 5)
/// @param flashDelay number of seconds to wait after the page has loaded if Flash elements are present. Use flash_delay=0 to take screenshots faster. (optional) (default to 10)
/// @param screenWidth width of the browser window. For desktop browsers only. (optional) (default to 1024)
/// @param screenHeight height of the browser window. For desktop browsers only. (Note: full-page screenshots can have a height of up to 15,000px) (optional) (default to 768)
/// @param priority assign priority to the screenshot (for private instances only) (optional)
/// @param referer use a custom referrer header - paid screenshots only (optional)
/// @param postData send a POST requests with post_data, useful for filling out forms - paid screenshots only (optional)
/// @param cookie set a cookie for the URL requested (see Custom POST Data, Referer and Cookie) Cookies should be separated by a ; - paid screenshots only (optional)
/// @param script URL of javascript file to execute after the page load event (optional)
/// @param details level of information available with screenshot/info (optional) (default to 2)
/// @param html saves the HTML of the rendered page which can be retrieved by the API call screenshot/html. This feature costs *1 credit* per screenshot. (optional) (default to 0)
/// @param maxWait maximum number of seconds to wait before triggering the PageLoad event. Note that delay will still be used. (default: 0 = disabled) (optional) (default to 0)
/// @param headers any custom HTTP headers. (Not supported with Internet Explorer) (optional)
/// @param format image as PNG or JPEG (optional) (default to png)
/// @param shots take multiple screenshots of the same page. This costs 1 additional credit for every 2 additional screenshots. (optional) (default to 1)
/// @param shotInterval number of seconds between 2 screenshots (optional) (default to 5)
///  code:200 message:"batch information",
///  code:0 message:"Batch not created"
/// @return NSArray<SWGBatch>*
-(NSNumber*) batchCeatePostWithInstanceId: (NSNumber*) instanceId
    file: (NSURL*) file
    size: (NSString*) size
    name: (NSString*) name
    width: (NSNumber*) width
    height: (NSNumber*) height
    delay: (NSNumber*) delay
    flashDelay: (NSNumber*) flashDelay
    screenWidth: (NSNumber*) screenWidth
    screenHeight: (NSNumber*) screenHeight
    priority: (NSNumber*) priority
    referer: (NSString*) referer
    postData: (NSString*) postData
    cookie: (NSString*) cookie
    script: (NSString*) script
    details: (NSNumber*) details
    html: (NSNumber*) html
    maxWait: (NSNumber*) maxWait
    headers: (NSString*) headers
    format: (NSString*) format
    shots: (NSNumber*) shots
    shotInterval: (NSNumber*) shotInterval
    completionHandler: (void (^)(NSArray<SWGBatch>* output, NSError* error)) handler;

/// Get the batch status
/// Get the status of a batch requested through the API or through the dashboard. 
///
/// @param _id batch ID
///  code:200 message:"batch information",
///  code:0 message:"Batch not found"
/// @return SWGBatch*
-(NSNumber*) batchInfoGetWithId: (NSNumber*) _id
    completionHandler: (void (^)(SWGBatch* output, NSError* error)) handler;


@end
